library MDIDLL;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  MDIBASE in 'MDIBASE.pas' {fmMDIBase},
  TEST in 'TEST.pas' {fmTest};

{$R *.RES}

function MDIChildEvent(FormCalssName: String; ParentApplication: TApplication; ParentForm: TForm): Longint; export; stdcall;
var
  AForm: TfmMDIBase;
  DllProc: Pointer;             { Called whenever DLL entry point is called }
  AClass: TPersistentClass;
begin
  Application := ParentApplication;
  try
    AClass := GetClass(FormCalssName);
    if (AClass <> nil) then
    begin
      AForm := TComponentClass(AClass).Create(Application) as TfmMDIBase;
      AForm.FormStyle := fsMDIChild;
    end;
  finally
    Result := Longint(AForm);
  end;
end;

procedure DLLUnloadProc(Reason: Integer); register;
begin
  if Reason = DLL_PROCESS_DETACH then  Application := DllApplication;
end;

exports
   MDIChildEvent;

begin
   DllApplication:=Application;
   DLLProc := @DLLUnloadProc;
end.
